// SetupDirectionDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SetupDirection.h"
#include "SetupDirectionDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetupDirectionDlg dialog

CSetupDirectionDlg::CSetupDirectionDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSetupDirectionDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSetupDirectionDlg)
	m_port = 0;
	m_LineSet = 0;
	m_LineGet = 0;
	m_SetDir = -1;
	m_GetSource = -1;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSetupDirectionDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetupDirectionDlg)
	DDX_Control(pDX, IDC_CHECK1, m_save);
	DDX_Text(pDX, IDC_EDIT1, m_port);
	DDX_Text(pDX, IDC_EDIT2, m_LineSet);
	DDX_Text(pDX, IDC_EDIT4, m_LineGet);
	DDX_Radio(pDX, IDC_RADIO1, m_SetDir);
	DDX_Radio(pDX, IDC_RADIO3, m_GetSource);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSetupDirectionDlg, CDialog)
	//{{AFX_MSG_MAP(CSetupDirectionDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnOpen)
	ON_BN_CLICKED(IDC_BUTTON2, OnSet)
	ON_BN_CLICKED(IDC_BUTTON3, OnGet)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetupDirectionDlg message handlers

BOOL CSetupDirectionDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
  m_hFile = NULL;
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSetupDirectionDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSetupDirectionDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSetupDirectionDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSetupDirectionDlg::OnOpen() 
{
	// TODO: Add your control notification handler code here
  UpdateData(true);

  if(this->m_hFile != NULL)
      CloseHandle(m_hFile);
  
  char COM_string[32];
  DCB dcb;	

	sprintf(COM_string,"\\\\.\\COM%d", this->m_port);
	m_hFile = CreateFile(COM_string, GENERIC_READ|GENERIC_WRITE, 0, NULL,						
	    OPEN_EXISTING, 0,NULL);

	if(m_hFile != INVALID_HANDLE_VALUE)
	{		
    GetCommState(m_hFile, &dcb);

		dcb.BaudRate  = CBR_9600;  // FORMALLY, CONNECT BAUD DOESN`T MATTER (Virtual Com Port)
		dcb.ByteSize  = 8;             
		dcb.Parity    = NOPARITY;        
		dcb.StopBits  = ONESTOPBIT;    

		COMMTIMEOUTS CommTimeOuts;
		CommTimeOuts.ReadIntervalTimeout          = MAXDWORD;
		CommTimeOuts.ReadTotalTimeoutMultiplier   = 0;
		CommTimeOuts.ReadTotalTimeoutConstant     = 0;
		CommTimeOuts.WriteTotalTimeoutMultiplier  = 0;
		CommTimeOuts.WriteTotalTimeoutConstant    = 1000;
		SetCommTimeouts(m_hFile, &CommTimeOuts);
		SetCommState(m_hFile, &dcb);
	}
	else 
	{
		MessageBox("Can`t Open Port", "Error", MB_ICONERROR);	
		return;
	}
	
  MessageBox("Open OK", "Info", MB_ICONINFORMATION);
	
}

//******************************************************************************
void CSetupDirectionDlg::OnSet() 
{
	// TODO: Add your control notification handler code here
  UpdateData(true);
  
  if(this->m_hFile == NULL)
  {
    MessageBox("You should open\nport first", "Info", MB_ICONINFORMATION);
    return;
  }

  int direction = this->m_SetDir;
  if(direction < 0)
  {
    MessageBox("Please, select\ndirection", "Info", MB_ICONINFORMATION);
    return;
  }

  if(this->m_LineSet <= 0 || this->m_LineSet > 24)
  {
    MessageBox("Please, select\ncorrect line number", "Info", MB_ICONINFORMATION);
    return;
  }  

  DWORD lpdwBytesWritten;
  char buf[32];

  int len = 0;
  if(this->m_save.GetCheck() == BST_CHECKED)
    len = sprintf(buf, "$KE,IO,SET,%d,%d,S\r\n", this->m_LineSet, direction);
  else
    len = sprintf(buf, "$KE,IO,SET,%d,%d\r\n", this->m_LineSet, direction);

  WriteFile(m_hFile, buf, len, &lpdwBytesWritten, NULL);  	

  MessageBox("Data has been\nsended to module", "Info", MB_ICONINFORMATION);
}


//*********************************************************************************
void CSetupDirectionDlg::OnGet() 
{
	// TODO: Add your control notification handler code here
  UpdateData(true);
  
  if(this->m_hFile == NULL)
  {
    MessageBox("You should open\nport first", "Info", MB_ICONINFORMATION);
    return;
  }

  int source = this->m_GetSource;
  if(source < 0)
  {
    MessageBox("Please, select\nsource", "Info", MB_ICONINFORMATION);
    return;
  }

  if(this->m_LineGet <= 0 || this->m_LineGet > 24)
  {
    MessageBox("Please, select\ncorrect line number", "Info", MB_ICONINFORMATION);
    return;
  }  

  DWORD lpdwBytesWritten;
  char buf[32];

  int len = 0;
  if(source == 0) // CUR
    len = sprintf(buf, "$KE,IO,GET,CUR,%d\r\n", this->m_LineGet);
  else            // MEM
    len = sprintf(buf, "$KE,IO,GET,MEM,%d\r\n", this->m_LineGet);

  WriteFile(m_hFile, buf, len, &lpdwBytesWritten, NULL);  


  // Make littele pause for wait module anser
  Sleep(100); // Wait 100 ms

  // Clear port buffer from previous data  
  //PurgeComm(m_hFile, PURGE_TXCLEAR );
  
	DWORD dwBytesRead;
	unsigned char pBuff[128];


	ReadFile(m_hFile, &pBuff, sizeof(pBuff), &dwBytesRead, NULL);

	if(dwBytesRead > 0)
	{
    // We must get anser like this: #IO,<value>

    if( memcmp(pBuff, "#IO,", 4) == 0)
    {
      int direction = atoi( (char*)(&pBuff[4]) );
      if(direction < 0 || direction > 1)
      {
        MessageBox("Get Line fail1", "Info", MB_ICONERROR);
        return;
      }

      CString s1;
      s1.Format("Direction Info:\nLine: %d\nSource: ", this->m_LineGet);

      if(source == 0) // CUR
        s1 += "CUR\n";
      else            // MEM
        s1 += "MEM\n";

      if(direction == 0)
        s1 += "Direction: OUT";
      else
        s1 += "Direction: IN";
      

      MessageBox(s1, "Info", MB_ICONINFORMATION);

    }
    else
    {
      MessageBox("Get Line fail2", "Info", MB_ICONERROR);
    }
    
  }
  else
  {
    MessageBox("Get Line fail3", "Info", MB_ICONERROR);
  }
}

